#!/usr/bin/perl

#
# This script extracts the alignments of a PSI-BLAST run.
#

#
# Martin Heusel
# Institute of Bioinformatics
# Johannes Kepler University Linz
# Austria
# http://www.bioinf.jku.at/
#
# v 1.0 30.07.2008
#
# $Id: extractAlignmentsFromBlastout.pl 42 2008-08-04 16:36:50Z mhe $
#

# ignore alignments longer than 1200 residues.
$maxseqlength = 1200;

# include only alignments with this e-value and below/better
$evaluethres = 10.0;


$file = shift;

open BL, "$file" or die "can't open $file $1";

while ($line = <BL>) {

    if ($line =~ /Expect\s=\s(.+),/) {
        #print $line;
        $exp = scalar $1;
        last;
    }

}

$seqline = "";

while ($line = <BL>) {
    if ($line =~ /Expect\s=\s(.+),/) {
        $exp = scalar $1;
        next;
    }
    if ($line =~ /^>/) {
        if (length($seqline) < $maxseqlength && $exp <= $evaluethres) {
            print $line;
            print "$seqline\n";
        }
        $seqline = "";
	next;
    }

    chomp $line;

    if ($line =~ /^Sbjct:/) {
        $line =~ s/Sbjct:\s+\d+\s+(.+)\s+\d+/$1/;
        $line =~ s/-+//g;
        $seqline .= $line;
    }

}
